﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace SlideVolume
{
	public partial class FormMain : Form
	{
		private struct SliderVolumeItem
		{
			public bool updated;
			public int value;
		}

		private SliderVolumeItem[] sf_sv = new SliderVolumeItem[31];
		private TrackBar[] sf_trackbars = new TrackBar[31];

		public FormMain()
		{
			InitializeComponent();

			sf_trackbars[0] = trackBar1;
			sf_trackbars[1] = trackBar2;
			sf_trackbars[2] = trackBar3;
			sf_trackbars[3] = trackBar4;
			sf_trackbars[4] = trackBar5;
			sf_trackbars[5] = trackBar6;
			sf_trackbars[6] = trackBar7;
			sf_trackbars[7] = trackBar8;
			sf_trackbars[8] = trackBar9;
			sf_trackbars[9] = trackBar10;
			sf_trackbars[10] = trackBar11;
			sf_trackbars[11] = trackBar12;
			sf_trackbars[12] = trackBar13;
			sf_trackbars[13] = trackBar14;
			sf_trackbars[14] = trackBar15;
			sf_trackbars[15] = trackBar16;
			sf_trackbars[16] = trackBar17;
			sf_trackbars[17] = trackBar18;
			sf_trackbars[18] = trackBar19;
			sf_trackbars[19] = trackBar20;
			sf_trackbars[20] = trackBar21;
			sf_trackbars[21] = trackBar22;
			sf_trackbars[22] = trackBar23;
			sf_trackbars[23] = trackBar24;
			sf_trackbars[24] = trackBar25;
			sf_trackbars[25] = trackBar26;
			sf_trackbars[26] = trackBar27;
			sf_trackbars[27] = trackBar28;
			sf_trackbars[28] = trackBar29;
			sf_trackbars[29] = trackBar30;
			sf_trackbars[30] = trackBar31;
		}

		private void FormMain_Load(object sender, EventArgs e)
		{
			string[] names = SerialPort.GetPortNames();
			comboBox1.Items.Clear();

			if (names.Length == 0)
				return;

			foreach (string name in names)
			{
				comboBox1.Items.Add(name);
			}

			if (comboBox1.SelectedIndex == -1)
				comboBox1.SelectedIndex = 0;
		}

		private void button1_Click(object sender, EventArgs e)
		{
			if (serialPort1.IsOpen)
			{
				serialPort1.Close();
				button1.Text = "Open";
				timer1.Enabled = false;
			}
			else
			{
				if (comboBox1.Text.Trim() == "")
				{
					MessageBox.Show(this, "COMポート名が入力されていません.", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}

				try
				{
					serialPort1.PortName = comboBox1.Text;
					serialPort1.BaudRate = 115200;
					serialPort1.DataBits = 8;
					serialPort1.Handshake = Handshake.None;
					serialPort1.Parity = Parity.None;
					serialPort1.StopBits = StopBits.One;
					serialPort1.Open();
					button1.Text = "Close";

					int l_band;
					for (l_band = 0; l_band < 31; l_band++)
					{
						sf_sv[l_band].updated = true;
					}

					timer1.Interval = 5;
					timer1.Enabled = true;
				}
				catch (Exception)
				{
					MessageBox.Show(this, "COMポートのオープンに失敗しました.", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}
			}
		}

		private void timer1_Tick(object sender, EventArgs e)
		{
			int l_lc;
			byte[] l_buf = new byte[2];
			byte l_value;

			if (!serialPort1.IsOpen) return;

			for (l_lc = 0; l_lc < 31; l_lc++)
			{
				if (sf_sv[l_lc].updated)
				{
					sf_sv[l_lc].updated = false;
					l_value = (byte)(sf_sv[l_lc].value + 128);
					l_buf[0] = (byte)(0x80 | ((byte)l_lc << 1) | (l_value >> 7));
					l_buf[1] = (byte)(l_value & 0x7F);
					serialPort1.Write(l_buf, 0, l_buf.Length);
				}
			}
		}

		private int convert_band(TrackBar bar)
		{
			int l_lc;

			for (l_lc = 0; l_lc < 31; l_lc++)
			{
				if (sf_trackbars[l_lc] == bar)
				{
					return l_lc;
				}
			}
			return -1;
		}

		private void trackBar_Scroll(object sender, EventArgs e)
		{
			int l_band = convert_band((TrackBar)sender);
			sf_sv[l_band].updated = true;
			sf_sv[l_band].value = ((TrackBar)sender).Value;

			if (checkBox1.Checked)
			{
				int l_value;
				/* 左の値を更新 */
				if (l_band > 1)
				{
					l_value = (int)(0.866 * (double)sf_sv[l_band].value);
					sf_sv[l_band - 1].value = l_value;
					sf_sv[l_band - 1].updated = true;
					sf_trackbars[l_band - 1].Value = l_value;
				}
				if (l_band > 2)
				{
					l_value = (int)(0.5 * (double)sf_sv[l_band].value);
					sf_sv[l_band - 2].value = l_value;
					sf_sv[l_band - 2].updated = true;
					sf_trackbars[l_band - 2].Value = l_value;
				}
				if (l_band > 3)
				{
					l_value = (int)(0.17 * (double)sf_sv[l_band].value);
					sf_sv[l_band - 3].value = l_value;
					sf_sv[l_band - 3].updated = true;
					sf_trackbars[l_band - 3].Value = l_value;
				}
				/* 右の値を更新 */
				if (l_band < 30)
				{
					l_value = (int)(0.866 * (double)sf_sv[l_band].value);
					sf_sv[l_band + 1].value = l_value;
					sf_sv[l_band + 1].updated = true;
					sf_trackbars[l_band + 1].Value = l_value;
				}
				if (l_band < 29)
				{
					l_value = (int)(0.5 * (double)sf_sv[l_band].value);
					sf_sv[l_band + 2].value = l_value;
					sf_sv[l_band + 2].updated = true;
					sf_trackbars[l_band + 2].Value = l_value;
				}
				if (l_band < 28)
				{
					l_value = (int)(0.17 * (double)sf_sv[l_band].value);
					sf_sv[l_band + 3].value = l_value;
					sf_sv[l_band + 3].updated = true;
					sf_trackbars[l_band + 3].Value = l_value;
				}
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			int l_band;
			for (l_band = 0; l_band < 31; l_band++)
			{
				sf_trackbars[l_band].Value = 0;
				sf_sv[l_band].updated = true;
				sf_sv[l_band].value = 0;
			}
		}

		private void FormMain_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (serialPort1.IsOpen)
			{
				e.Cancel = true;
				MessageBox.Show(this, "COMポートをCloseして下さい.", "メッセージ", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}

		delegate void UpdateVolumeLevel(int channel, int volume);

		private void update_volume(int channel, int volume)
		{
			if(channel == 0)
				progressBar1.Value = volume;
			else
				progressBar2.Value = volume;
		}

		private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
		{
			int l_val = 0;
			if (serialPort1.BytesToRead == 0) return;
			while(serialPort1.BytesToRead > 0) l_val = serialPort1.ReadByte();

			int l_channel = l_val >> 7;
			l_val &= 0x7F;
			if(l_val == 0) l_val = 1;
			l_val = (int)(20 * Math.Log10((double)l_val));

			Invoke(new UpdateVolumeLevel(update_volume), l_channel, l_val);
		}
	}
}
